/*
 * Copyright 2023 peter.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package hk.quantr.qemulogpanel;

import hk.quantr.javalib.CommonLib;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collections;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;

/**
 *
 * @author peter
 */
public class CompareDialog extends javax.swing.JDialog {

	DefaultListModel<String> qemuListModel = new DefaultListModel();
	DefaultListModel<String> quantrListModel = new DefaultListModel();
	File database;
	CompareTableModel model = new CompareTableModel();
	public boolean process;
	public long sequence;

	/**
	 * Creates new form CompareDialog
	 */
	public CompareDialog(java.awt.Frame parent, boolean modal, File database) {
		super(parent, modal);
		this.database = database;

		initComponents();
		init(database);
		loadSetting();

		jTable1.getColumnModel().getColumn(2).setWidth(300);
	}

	private void init(File database) {
		try {
			Connection qemuConn = DriverManager.getConnection("jdbc:h2:" + database.getAbsolutePath().replace(".mv.db", ""), "sa", "");
			Statement qemuStmt = qemuConn.createStatement();
			ResultSet rs = qemuStmt.executeQuery("show columns from `qemu`;");
			ArrayList<String> temp = new ArrayList();
			while (rs.next()) {
				String columnName = rs.getString("column_name");
				temp.add(columnName);
			}
			Collections.sort(temp, String.CASE_INSENSITIVE_ORDER);
			qemuListModel.addAll(temp);

			rs = qemuStmt.executeQuery("show columns from `quantr`;");
			temp = new ArrayList();
			while (rs.next()) {
				String columnName = rs.getString("column_name");
				temp.add(columnName);
			}
			Collections.sort(temp, String.CASE_INSENSITIVE_ORDER);
			quantrListModel.addAll(temp);

			quantrScrollPane.getVerticalScrollBar().addAdjustmentListener(new AdjustmentListener() {
				@Override
				public void adjustmentValueChanged(AdjustmentEvent e) {
//					qemuScrollPane.getVerticalScrollBar().setValue(e.getValue());
				}
			});

			qemuScrollPane.getVerticalScrollBar().addAdjustmentListener(new AdjustmentListener() {
				@Override
				public void adjustmentValueChanged(AdjustmentEvent e) {
//					quantrScrollPane.getVerticalScrollBar().setValue(e.getValue());
				}
			});

		} catch (SQLException ex) {
			Logger.getLogger(CompareDialog.class.getName()).log(Level.SEVERE, null, ex);
		}
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        qemuScrollPane = new javax.swing.JScrollPane();
        qemuList = new javax.swing.JList<>();
        jPanel5 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        quantrScrollPane = new javax.swing.JScrollPane();
        quantrList = new javax.swing.JList<>();
        jPanel6 = new javax.swing.JPanel();
        fromTextField = new javax.swing.JFormattedTextField();
        jLabel3 = new javax.swing.JLabel();
        toTextField = new javax.swing.JFormattedTextField();
        jLabel4 = new javax.swing.JLabel();
        limitTextField = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        buildIndexCheckBox = new javax.swing.JCheckBox();
        jLabel5 = new javax.swing.JLabel();
        compareNoOfByteComboBox = new javax.swing.JComboBox<>();
        jLabel6 = new javax.swing.JLabel();
        excludeMemAddrTextField = new javax.swing.JTextField();
        compareButton = new javax.swing.JButton();
        jPanel7 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Compare");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));

        jPanel3.setPreferredSize(new java.awt.Dimension(552, 250));
        jPanel3.setLayout(new javax.swing.BoxLayout(jPanel3, javax.swing.BoxLayout.LINE_AXIS));

        jPanel4.setLayout(new javax.swing.BoxLayout(jPanel4, javax.swing.BoxLayout.Y_AXIS));

        jLabel1.setText("Qemu");
        jPanel4.add(jLabel1);

        qemuScrollPane.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));

        qemuList.setModel(qemuListModel);
        qemuScrollPane.setViewportView(qemuList);

        jPanel4.add(qemuScrollPane);

        jPanel3.add(jPanel4);

        jPanel5.setLayout(new javax.swing.BoxLayout(jPanel5, javax.swing.BoxLayout.Y_AXIS));

        jLabel2.setText("Quantr");
        jPanel5.add(jLabel2);

        quantrScrollPane.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));

        quantrList.setModel(quantrListModel);
        quantrList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                quantrListMouseClicked(evt);
            }
        });
        quantrScrollPane.setViewportView(quantrList);

        jPanel5.add(quantrScrollPane);

        jPanel3.add(jPanel5);

        jPanel1.add(jPanel3);

        jPanel6.setMaximumSize(new java.awt.Dimension(32767, 40));

        fromTextField.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        fromTextField.setText("0");
        fromTextField.setPreferredSize(new java.awt.Dimension(180, 24));
        jPanel6.add(fromTextField);

        jLabel3.setText("To");
        jPanel6.add(jLabel3);

        toTextField.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        toTextField.setText("200,000,000");
        toTextField.setPreferredSize(new java.awt.Dimension(180, 24));
        jPanel6.add(toTextField);

        jLabel4.setText("Limit");
        jPanel6.add(jLabel4);

        limitTextField.setText("1000");
        limitTextField.setPreferredSize(new java.awt.Dimension(80, 24));
        jPanel6.add(limitTextField);

        jPanel1.add(jPanel6);

        jPanel2.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.LINE_AXIS));

        buildIndexCheckBox.setText("Build Index (So next time run faster)");
        jPanel2.add(buildIndexCheckBox);

        jLabel5.setText("Compare only this no of byte");
        jLabel5.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 40, 0, 5));
        jPanel2.add(jLabel5);

        compareNoOfByteComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "100", "1", "2", "4", "8" }));
        compareNoOfByteComboBox.setMaximumSize(new java.awt.Dimension(100, 23));
        jPanel2.add(compareNoOfByteComboBox);

        jLabel6.setText("Exclude Memaddr");
        jPanel2.add(jLabel6);

        excludeMemAddrTextField.setMaximumSize(new java.awt.Dimension(200, 23));
        jPanel2.add(excludeMemAddrTextField);

        compareButton.setText("Compare");
        compareButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                compareButtonActionPerformed(evt);
            }
        });
        jPanel2.add(compareButton);

        jPanel1.add(jPanel2);

        jPanel7.setLayout(new java.awt.BorderLayout());

        jTable1.setModel(model);
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTable1MouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(jTable1);

        jPanel7.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel1.add(jPanel7);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        setBounds(0, 0, 1192, 883);
    }// </editor-fold>//GEN-END:initComponents

    private void compareButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compareButtonActionPerformed
		try {
			String qemu = qemuList.getSelectedValue();
			String quantr = quantrList.getSelectedValue();
			Connection qemuConn = DriverManager.getConnection("jdbc:h2:" + database.getAbsolutePath().replace(".mv.db", ""), "sa", "");
			Statement stmt = qemuConn.createStatement();
			if (buildIndexCheckBox.isSelected()) {
				String sql = "create index if not exists `qemu_" + qemu + "` on qemu(`" + qemu + "`);";
				System.out.println(sql);
				stmt.execute(sql);
				sql = "create index if not exists `quantr_" + quantr + "` on quantr(`" + quantr + "`);";
				System.out.println(sql);
				stmt.execute(sql);
			}
			String sql;
			int noOfByte = Integer.parseInt((String) compareNoOfByteComboBox.getSelectedItem());
			if (noOfByte != 100) {
				int p = (int) Math.pow(2, noOfByte * 8) - 1;
				sql = "select * from `qemu` left join quantr on qemu.`sequence`=quantr.`sequence` where bitand(`qemu`.`" + qemu + "`," + p + ")!=bitand(`quantr`.`" + quantr + "`," + p + ") and `qemu`.sequence>=" + fromTextField.getText().replaceAll(",", "") + " and `qemu`.sequence<=" + toTextField.getText().replaceAll(",", "") + " order by sequence limit " + limitTextField.getText() + ";";
			} else {
				sql = "select * from `qemu` left join quantr on qemu.`sequence`=quantr.`sequence` where `qemu`.`" + qemu + "`!=`quantr`.`" + quantr + "` and `qemu`.sequence>=" + fromTextField.getText().replaceAll(",", "") + " and `qemu`.sequence<=" + toTextField.getText().replaceAll(",", "") + " order by sequence limit " + limitTextField.getText() + ";";
			}
			System.out.println(sql);
			ResultSet rs = stmt.executeQuery(sql);
			model.data.clear();

			Statement stmt2 = qemuConn.createStatement();

			ArrayList<Long> excludeMemAddr = new ArrayList();
			for (String str : excludeMemAddrTextField.getText().split(",")) {
				if (str.length() > 0) {
					excludeMemAddr.add(CommonLib.string2long(str.trim()));
				}
			}

			while (rs.next()) {
//				System.out.println(rs.getLong("sequence") + ", " + rs.getLong("pc"));
				String temp[] = new String[6];
				long tempSeq = rs.getLong("sequence");
				if (tempSeq > 0) {
					ResultSet rs2 = stmt2.executeQuery("select * from qemu where sequence=" + (tempSeq - 1));
					rs2.next();
					temp[0] = String.valueOf(rs2.getLong("sequence"));
					temp[1] = String.valueOf(rs2.getLong("pc"));
					temp[2] = rs2.getString("code");
				}

				temp[3] = String.valueOf(rs.getLong("memaddr"));
				temp[4] = rs.getString("qemu." + qemu);
				temp[5] = rs.getString("quantr." + quantr);
				if (excludeMemAddr.indexOf(rs.getLong("memaddr")) == -1) {
					model.data.add(temp);
				}
			}
			model.fireTableDataChanged();
			CommonLib.autoResizeColumn(jTable1);
		} catch (SQLException ex) {
			Logger.getLogger(CompareDialog.class.getName()).log(Level.SEVERE, null, ex);
		}
		System.out.println("compare done");
    }//GEN-LAST:event_compareButtonActionPerformed

    private void quantrListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_quantrListMouseClicked
		if (qemuList.getSelectedIndex() == -1) {
			qemuList.setSelectedIndex(quantrList.getSelectedIndex());
		}
    }//GEN-LAST:event_quantrListMouseClicked

    private void jTable1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseClicked
		if (evt.getClickCount() == 2) {
			sequence = CommonLib.string2long(((String) jTable1.getValueAt(jTable1.getSelectedRow(), 0)).replaceAll(" ", ""));
			process = true;
			saveSetting();
			setVisible(false);
		}
    }//GEN-LAST:event_jTable1MouseClicked

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
		saveSetting();
    }//GEN-LAST:event_formWindowClosing

	private void saveSetting() {
		Setting.getInstance().compareDialog_from = fromTextField.getText();
		Setting.getInstance().compareDialog_to = toTextField.getText();
		Setting.getInstance().compareDialog_limit = limitTextField.getText();
		Setting.getInstance().compareDialog_qemu = qemuList.getSelectedValue();
		Setting.getInstance().compareDialog_quantr = quantrList.getSelectedValue();
		Setting.getInstance().compareDialog_excludeMemAddr = excludeMemAddrTextField.getText();
		Setting.getInstance().save();
	}

	private void loadSetting() {
		if (Setting.getInstance().compareDialog_from != null) {
			fromTextField.setText(Setting.getInstance().compareDialog_from);
		}
		if (Setting.getInstance().compareDialog_to != null) {
			toTextField.setText(Setting.getInstance().compareDialog_to);
		}
		if (Setting.getInstance().compareDialog_limit != null) {
			limitTextField.setText(Setting.getInstance().compareDialog_limit);
		}
		if (Setting.getInstance().compareDialog_qemu != null) {
			for (int x = 0; x < qemuList.getModel().getSize(); x++) {
				if (qemuList.getModel().getElementAt(x).equals(Setting.getInstance().compareDialog_qemu)) {
					qemuList.setSelectedIndex(x);
					qemuList.ensureIndexIsVisible(x);
					break;
				}
			}
		}
		if (Setting.getInstance().compareDialog_quantr != null) {
			for (int x = 0; x < quantrList.getModel().getSize(); x++) {
				if (quantrList.getModel().getElementAt(x).equals(Setting.getInstance().compareDialog_quantr)) {
					quantrList.setSelectedIndex(x);
					quantrList.ensureIndexIsVisible(x);
					break;
				}
			}
		}
		if (Setting.getInstance().compareDialog_excludeMemAddr != null) {
			excludeMemAddrTextField.setText(Setting.getInstance().compareDialog_excludeMemAddr);
		}
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox buildIndexCheckBox;
    private javax.swing.JButton compareButton;
    private javax.swing.JComboBox<String> compareNoOfByteComboBox;
    private javax.swing.JTextField excludeMemAddrTextField;
    private javax.swing.JFormattedTextField fromTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField limitTextField;
    public javax.swing.JList<String> qemuList;
    private javax.swing.JScrollPane qemuScrollPane;
    public javax.swing.JList<String> quantrList;
    private javax.swing.JScrollPane quantrScrollPane;
    private javax.swing.JFormattedTextField toTextField;
    // End of variables declaration//GEN-END:variables
}
